"{ Encoding: utf8 }"

"{ Package: 'jv:statascripteditor' }"

"{ NameSpace: Smalltalk }"

MultiViewToolApplication subclass:#StataScriptEditor
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Stata Script Editor'
!


!StataScriptEditor class methodsFor:'menu specs'!

mainMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."


    "
     MenuEditor new openOnClass:StataScriptEditor andSelector:#mainMenu
     (Menu new fromLiteralArrayEncoding:(StataScriptEditor mainMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(Menu
        (
         (MenuItem
            label: 'File'
            submenu: 
           (Menu
              (
               (MenuItem
                  label: 'New'
                  itemValue: newWorkspace
                  shortcutKey: Ctrlt
                )
               (MenuItem
                  label: 'New Window'
                  itemValue: newWindow
                  shortcutKey: Ctrln
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'Open...'
                  itemValue: menuLoad
                  shortcutKey: Ctrlo
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'Save'
                  itemValue: menuSave
                  shortcutKey: Ctrls
                )
               (MenuItem
                  label: 'Save As...'
                  itemValue: menuSaveAs
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'Exit'
                  itemValue: closeRequest
                )
               )
              nil
              nil
            )
          )
         (MenuItem
            label: 'Buffers'
            nameKey: Buffer
            submenu: 
           (Menu
              (
               (MenuItem
                  label: 'Add Buffer'
                  itemValue: addWorkspace
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'Rename...'
                  itemValue: renameWorkspace
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  enabled: canRemoveWorkspace
                  label: 'Remove Buffer'
                  itemValue: removeWorkspace
                )
               )
              nil
              nil
            )
          )
         (MenuItem
            label: 'Edit'
            submenu: 
           (Menu
              (
               (MenuItem
                  enabled: hasSelectionInActiveWorkspace
                  label: 'Cut'
                  itemValue: cutSelection
                )
               (MenuItem
                  enabled: hasSelectionInActiveWorkspace
                  label: 'Copy'
                  itemValue: copySelection
                )
               (MenuItem
                  label: 'Paste'
                  itemValue: paste
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'Select All'
                  itemValue: selectAll
                )
               )
              nil
              nil
            )
          )
         (MenuItem
            label: 'View'
            submenuChannel: viewMenu
            keepLinkedMenu: true
          )
         (MenuItem
            label: 'MENU_Help'
            startGroup: conditionalRight
            submenu: 
           (Menu
              (
               (MenuItem
                  label: 'Documenation'
                  itemValue: openDocumentation
                )
               (MenuItem
                  label: 'Report Problem'
                  itemValue: openBug
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'About this Application...'
                  itemValue: openAboutThisApplication
                )
               )
              nil
              nil
            )
          )
         )
        nil
        nil
      )
! !

!StataScriptEditor methodsFor:'change & update'!

windowLabelPrefix
    ^ 'STATA Script Editor'

    "Created: / 17-03-2015 / 04:30:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!StataScriptEditor methodsFor:'defaults'!

defaultFileNameForLoad
   ^ LastOpenedFile

    "Created: / 25-10-2006 / 14:56:19 / cg"
    "Modified: / 10-02-2015 / 22:31:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

defaultPatternLoad
   ^ '*.do; *.smcl'

    "Created: / 25-10-2006 / 14:57:18 / cg"
    "Modified: / 10-02-2015 / 22:33:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!StataScriptEditor methodsFor:'help'!

aboutThisApplicationText
    "text for an about box for this application.
     Extracts some common info (i.e. class revision, author etc.) from
     the classes documentation."

    ^ resources 
        stringWithCRs: 'STATA Script Editor (rev %1)\\https://bitbucket.org/janvrany/jv-statascripteditor/wiki/Home\\(C) 2015 Jan Vrany'
                 with: (self class revision ? '0.1')

    "Created: / 17-03-2015 / 04:14:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!StataScriptEditor methodsFor:'hooks'!

postBuildWith:aBuilder
    super postBuildWith:aBuilder.
    self window label:self windowLabelPrefix

    "Created: / 17-03-2015 / 04:22:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!StataScriptEditor methodsFor:'menu actions'!

menuSave
    "automatically generated by UIEditor ..."

    "*** the code below performs no action"
    "*** (except for some feedback on the Transcript)"
    "*** Please change as required and accept in the browser."
    "*** (and replace this comment by something more useful ;-)"

    "action to be added ..."

    Transcript showCR:self class name, ': action for #menuSave ...'.
!

openBug
    OperatingSystem 
        openApplicationForDocument: 'https://bitbucket.org/janvrany/jv-statascripteditor/issues/new'
                         operation: #open

    "Modified: / 17-03-2015 / 04:19:36 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

openDocumentation
    OperatingSystem 
        openApplicationForDocument: 'https://bitbucket.org/janvrany/jv-statascripteditor/wiki/Home'
                         operation: #open

    "Modified: / 17-03-2015 / 04:17:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!StataScriptEditor methodsFor:'menu-actions'!

loadFile:aFileName encoding:encodingSymbolOrNil label:label
    |file ws|

    file := aFileName asFilename.
    [
        | contents |

        file suffix = 'smcl' ifTrue:[ 
            contents := StataScriptLogImporter new import: file  
        ] ifFalse:[ 
            contents := file contents.
        ].

        ws := self selectedWorkspacesTextView. 
        ws contents asString indexOfNonSeparator ~~ 0 ifTrue:[ 
            self addWindow: self createWorkspace named: label.
            ws := self selectedWorkspacesTextView. 
        ].


        encodingSymbolOrNil notNil ifTrue:[
            contents := contents encodeFrom:encodingSymbolOrNil into:#'unicode'.
            ws externalEncoding:encodingSymbolOrNil.
        ].
        ws contents:contents.
        ws defaultFileNameForFileDialog:file pathName.
    ] on:StreamError do:[:ex|
        Dialog warn:(resources stringWithCRs:'Cannot open "%1":\\%2' with:file asString with:ex description).
        ^ self
    ].
    ws modified:false.
    self setLabel:label.

    "Created: / 11-02-2015 / 00:32:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 17-03-2015 / 04:28:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

menuLoad
    | file |

    file := Dialog 
                requestFileName:(resources string:'Open file') 
                default:(self defaultFileNameForLoad) 
                pattern:(self defaultPatternLoad).
    file size ~~ 0 ifTrue:[
        self loadFile:file
    ]

    "Created: / 10-02-2015 / 22:30:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!StataScriptEditor methodsFor:'private'!

createWorkspace
    |ws|

    ws := (HVScrollableView for:Tools::CodeView2).
    ^ ws

    "Modified: / 09-12-2010 / 10:55:25 / cg"
    "Modified: / 05-02-2015 / 06:28:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

isModifiedWorkspace:aView
    ^ aView isModified

    "Created: / 05-02-2015 / 06:22:57 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!StataScriptEditor class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

